searchData={"items":[{"type":"module","title":"CtrDrbg","doc":"Pure Elixir implementation of the CTR_DRBG PRNG algorithm.","ref":"CtrDrbg.html"},{"type":"module","title":"Examples - CtrDrbg","doc":"iex> state = CtrDrbg.init(:crypto.strong_rand_bytes(16))\n    iex> {state, random_bytes} = CtrDrbg.generate(state, 32)\n    {#CtrDrbg ,  >}","ref":"CtrDrbg.html#module-examples"},{"type":"function","title":"CtrDrbg.generate/3","doc":"Generate an arbitrary number of random bytes.","ref":"CtrDrbg.html#generate/3"},{"type":"function","title":"CtrDrbg.init/2","doc":"Initialize and seed the generator.","ref":"CtrDrbg.html#init/2"},{"type":"function","title":"CtrDrbg.reseed/3","doc":"Reseed the generator.","ref":"CtrDrbg.html#reseed/3"},{"type":"opaque","title":"CtrDrbg.t/0","doc":"The current PRNG state.","ref":"CtrDrbg.html#t:t/0"},{"type":"extras","title":"CtrDrbg","doc":"# CtrDrbg [![Hex Version](https://img.shields.io/hexpm/v/ctr_drbg.svg)](https://hex.pm/packages/ctr_drbg) [![Hex Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/ctr_drbg/)\n\nA pure Elixir implementation of the CTR_DRBG PRNG algorithm.","ref":"readme.html"},{"type":"extras","title":"Supported Functionality - CtrDrbg","doc":"- Ciphers\n  - [x] AES-128\n  - [ ] AES-192\n  - [ ] AES-256\n  - [ ] Triple DES\n- [x] Personalization string\n- [ ] Reseeding counter\n- [ ] Prediction resistance\n- [ ] Derivation function\n- [ ] Security strength option","ref":"readme.html#supported-functionality"},{"type":"extras","title":"Installation - CtrDrbg","doc":"Add `ctr_drbg` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ctr_drbg, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Tests - CtrDrbg","doc":"The test vectors under `text/fixtures` were retrieved from the [NIST's Cryptographic\nAlgorithm Validation Program](https://csrc.nist.gov/projects/cryptographic-algorithm-validation-program/random-number-generators#DRBG) (`drbgvectors_pr_false/CTR_DRBG.rsp` in the `drbgtestvectors.zip` archive).","ref":"readme.html#tests"},{"type":"extras","title":"Benchmarks - CtrDrbg","doc":"```text\n$> mix benchmark\n\nGenerated ctr_drbg app\nOperating System: macOS\nCPU Information: Apple M1 Max\nNumber of Available Cores: 10\nAvailable memory: 32 GB\nElixir 1.15.4\nErlang 26.0.2\n\nBenchmark suite executing with the following configuration:\nwarmup: 2 s\ntime: 5 s\nmemory time: 0 ns\nreduction time: 0 ns\nparallel: 1\ninputs: 16 bytes, 32 bytes, 64 bytes\nEstimated total run time: 21 s\n\nBenchmarking CtrDrbg.generate/2 with input 16 bytes ...\nBenchmarking CtrDrbg.generate/2 with input 32 bytes ...\nBenchmarking CtrDrbg.generate/2 with input 64 bytes ...\n\n###","ref":"readme.html#benchmarks"},{"type":"extras","title":"With input 16 bytes ##### - CtrDrbg","doc":"Name                         ips        average  deviation         median         99th %\nCtrDrbg.generate/2      427.59 K        2.34 μs  ±2044.84%        1.54 μs        3.58 μs\n\n###","ref":"readme.html#with-input-16-bytes"},{"type":"extras","title":"With input 32 bytes ##### - CtrDrbg","doc":"Name                         ips        average  deviation         median         99th %\nCtrDrbg.generate/2      401.58 K        2.49 μs   ±978.15%        1.92 μs        4.79 μs\n\n###","ref":"readme.html#with-input-32-bytes"},{"type":"extras","title":"With input 64 bytes ##### - CtrDrbg","doc":"Name                         ips        average  deviation         median         99th %\nCtrDrbg.generate/2      278.11 K        3.60 μs   ±558.63%        2.83 μs        7.25 μs\n```","ref":"readme.html#with-input-64-bytes"}],"content_type":"text/markdown"}